<?
    // получение записи из БД
    global $wpdb;
    $table_name = $wpdb->get_blog_prefix() . 'pechka_kkm_table';
    $taxes_table = $wpdb->get_blog_prefix() . 'pechka_kkm_tax';
    $product = $wpdb->get_row("SELECT * FROM {$table_name}");
    $taxes = $wpdb->get_results("SELECT * FROM {$taxes_table}");
    $array = json_decode(json_encode($product), true);
    $taxes_array = json_decode(json_encode($taxes), true);
?>

<div class="wrap">

    <h1>Pechka 54</h1>
    <h1 class="wp-heading-inline">ККМ</h1>

    <table class="wp-list-table widefat fixed striped posts">
        <thead>
        <tr>
            <th>Последнее активность</th>
            <th>Последнее обновление</th>
            <th>Наименование ККМ</th>
            <th>Состояние ККМ</th>
            <th>Серийный номер ККМ</th>
            <th>ИНН ККМ</th>
        </tr>
        </thead>
        <tbody>
        <tr>
            <th scope="col">
                <?= $array['lasttime']; ?>
            </th>
            <? if ($array['action'] == 'N') { ?>
                <th scope="col">
                    <?= $array['time']; ?>
                </th>
            <? } else { ?>
                <th scope="col">
                    <?= $array['lasttime']; ?>
                </th>
            <? } ?>
            <th scope="col">
                <?= $array['name']; ?>
            </th>
            <? if ($array['action'] == 'Y') { ?>
                <th>ККМ подключена</th>
            <? } else { ?>
                <th>нет данных от ККМ</th>
            <? } ?>
            <th scope="col">
                <?= $array['serial']; ?>
            </th>
            <th scope="col">
                <?= $array['inn']; ?>
            </th>
        </tr>
        </tbody>
    </table>
    <table class="wp-list-table widefat fixed striped posts">
        <div style="width:25%; float: left">
            <h1 class="wp-heading-inline">Выбор способов оплаты</h1>
            <form method="POST">
                <select id="paymethod" name="paymethod[]" multiple="multiple" style="width:80%;">
                    <?
                        $sel = explode(",", $array['paymethod']);
                        // вывожу только активные методы оплаты
                        $gateway = get_pages();
                        foreach (WC()->payment_gateways->payment_gateways() as $gateway) {
                            $select = '';
                            if (in_array($gateway->id, $sel)) {
                                $select = 'selected';
                            }
                            if (esc_html($gateway->enabled) != 'no') {
                                echo '<option value="' . esc_html($gateway->id) . '" ' . $select . '>' . esc_html($gateway->title) . '</option>';
                            }
                        }
                    ?>
                </select>
                <?
                    // записываю выбранные методы оплаты в таблицу ККМ
                    if (isset($_POST['paymethod'])) {
                        $paym = implode(",", $_POST['paymethod']);
                        $wpdb->update(
                            $table_name,
                            array('paymethod' => $paym),
                            array('ID' => lastRowId())
                        );
                        header("Refresh:0");
                    }
                ?>
                <p class="submit">
                    <input type="submit" class="button-primary" value="Сохранить способ оплаты" />
                </p>
            </form>
        </div>
        <div style="width:25%; float: left">
            <h1 class="wp-heading-inline">E_mail для уведомлений</h1>
            <form method="post" action="options.php">
                <?php wp_nonce_field('update-options'); ?>
                <input type="text" name="e_mail" value="<?php echo get_option('e_mail'); ?>"
                       style="width:80%; margin-top:2em;"/>
                <p>можно записать несколько e_mail через запятую</p>
                <input type="hidden" name="action" value="update"/>
                <input type="hidden" name="page_options" value="e_mail"/>
                <p class="submit">
                    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>"/>
                </p>
            </form>
        </div>

        <div style="width:25%; float: left">
            <h1 class="wp-heading-inline">Настройка ндс</h1>

            <form method="POST">
                <?
                    if (wc_tax_enabled()) {
                        $tax_items1 = new WC_Tax();

                        $taxes1 = $tax_items1->get_tax_classes();

                        $cms_taxes_id_list = [];
                        $kkm_tax_id_list = [];

                        foreach ($taxes_array as $tax3) {
                            array_push($kkm_tax_id_list, $tax3["id"]);
                        }

                        foreach ($taxes1 as $tax1) {

                            $rates1 = $wpdb->get_results($wpdb->prepare("SELECT * FROM `{$wpdb->prefix}woocommerce_tax_rates` WHERE `tax_rate_class` = %s;", sanitize_title($tax1)));
                            $rates1 = json_decode(json_encode($rates1), true);

                            foreach ($rates1 as $rates1_item) {

                                array_push($cms_taxes_id_list, $rates1_item["tax_rate_id"]);

                                echo '<div>
                                <label for="' . $rates1_item["tax_rate_id"] . '">' . urldecode($rates1_item["tax_rate_name"]) . '</label>
                                <select id="' . $rates1_item["tax_rate_id"] . '" name="' . $rates1_item["tax_rate_id"] . '[]' . '" data-taxe-rate="' . $rates1_item["tax_rate"] . '" style="width:60%; float: right;">';

                                $i = 0;
                                foreach ($taxes_array as $tax2) {
                                    $cms_tax_id_list = explode(",", $tax2['cmstaxid']);

                                    if ($i == 0) {
                                        echo '<option value="">' . 'значение не выбрано' . '</option>';
                                    }

                                    $select = '';

                                    if (in_array($rates1_item["tax_rate_id"], $cms_tax_id_list)) {
                                        $select = 'selected';
                                    }

                                    echo '<option value="' . esc_html($tax2["id"]) . '" ' . $select . '>' . esc_html($tax2["kkmtax"]) . '</option>';
                                    $i++;
                                }

                                echo '</select> </div> <br>';
                            }
                        }

                        echo '<p class="submit">
                                <input type="submit" class="button-primary" value="Сохранить настройки ндс" name="upadate_tax_value"/>
                             </p>';

                        if (isset($_POST['upadate_tax_value'])) {
                            update_tax_value($cms_taxes_id_list, $kkm_tax_id_list, $taxes_table);
                            header("Refresh:0");
                        }

                    } else {
                        echo 'Использование налогов не включено';
                    }
                ?>
            </form>
        </div>
        <?
            // запись списка получателей уведомлений в БД
            $e_mail = get_option('e_mail');
            if (!empty($e_mail)) {
                $wpdb->update(
                    $table_name,
                    array('adressmail' => $e_mail),
                    array('ID' => lastRowId())
                );
            }
        ?>
    </table>
    <h1 class="wp-heading-inline">Заказы</h1>
    <table class="wp-list-table widefat fixed striped posts">
        <thead>
        <tr>
            <th style="width:7%">Номер заказа</th>
            <th>Дата оплаты заказа</th>
            <th>Дата печати заказа</th>
            <th>Серийный номер ККМ</th>
            <th style="width:7%">Номер смены</th>
            <th style="width:33%">Статус печати</th>
            <th>Ссылка на чек ОФД</th>
        </tr>
        </thead>
        <tbody>
        <?
            $table_name = $wpdb->get_blog_prefix() . 'pechka_kkm_order';
            $orders = $wpdb->get_results("SELECT * FROM {$table_name}");
            foreach ($orders as $order) {
                $orderId = $order->id;
                $orderTime = $order->time;
                $orderLastTime = $order->lasttime;
                $orderKkm = $order->kkm;
                $orderShiftNumber = $order->shiftnumber;
                $orderResultCode = $order->resultcode;
                $orderResultInfo = $order->resultinfo;
                $orderOFDLink = $order->OFDLink;
                ?>
                <tr>
                    <th><?=$orderId?></th>
                    <th><?=$orderTime?></th>
                    <th><?=$orderLastTime?></th>
                    <th><?=$orderKkm?></th>
                    <th><?=$orderShiftNumber?></th>
                    <? if ($orderResultCode == '0') { ?>
                        <th>Чек распечатан</th>
                    <? } else if ($orderResultCode == '-1') { ?>
                        <th>Чек ожидает печати</th>
                    <? } else { ?>
                        <th><?=$orderResultInfo?></th>
                    <? } ?>
                    <? if ($orderResultCode == '4') { ?>
                        <?
                        if (isset($_POST['send_check'])) {
                            $wpdb->update(
                                $table_name,
                                array('resultcode' => '-1'),
                                array('ID' => $orderId)
                            );
                            header("Refresh:0");
                        }
                        ?>
                        <th>
                            <form method="POST">
                                <input type="submit" class="button-primary" name="send_check" value="Повторить печать чека?" />
                            </form>
                        </th>
                    <? } ?>
                    <? if (!empty($orderOFDLink)) { ?>
                        <? if (!$orderResultCode == '-1') { ?>
                            <th>
                                <a href="<?=$orderOFDLink?>" target="_blank" style="text-decoration: none;">Чек заказа №<?=$orderId?></a>
                            </th>
                        <? } ?>
                    <? } ?>
                </tr>
            <? } ?>
        </tbody>
    </table>
    <div>
    </div><!-- .wrap -->